Hooks:PostHook(NewRaycastWeaponBase, "_update_stats_values", "dropshot_newstats", function(self, params)
-- non-shotgun falloff
-- mechanics are inconsistent with normal payday because i wrote this once for myself and i couldn't be fucked to mess with it

--[[
WEAPONtweakdata
self.weaponid.falloff_min_dmg = x
	x = damage at end of falloff range
		uses internal payday math so 45 in-game damage is represented here as 4.5
self.weaponid.falloff_begin = x
self.weaponid.falloff_end = x
	x = distance in centimeters, so 2000 = 20m
		default is 20m/40m
		does not work like shotgun falloffs where total falloff range is damage_near + damage_far
		here, falloff_end is the actual end distance where you're doing 0 damage
--]]

--[[
WEAPONFACTORYtweakdata
self.parts.weaponpart.custom_stats = {falloff_begin_mult = x, falloff_end_mult = x, falloff_min_dmg_penalty = y}
	x = multiplier on non-shotgun falloff
		see above for specific info on how non-shotgun falloff distances work
	y = damage amount that this part subtracts from falloff_min_dmg, represented with in-game damage (so 45 is actually 45 in-game damage this time)
		weapons with no defined falloff_min_dmg just subtract from the actual damage
		remember, positive value here reduces final damage
		i told you i was going to spaghetti my way into inconsistency
--]]

	self._falloff_min_dmg = self:weapon_tweak_data().falloff_min_dmg or nil
	self._falloff_min_dmg_penalty = 0
	self._falloff_begin = self:weapon_tweak_data().falloff_begin or 2000 -- 20m
	self._falloff_end = self:weapon_tweak_data().falloff_end or 4000 -- 40m

	local custom_stats = managers.weapon_factory:get_custom_stats_from_weapon(self._factory_id, self._blueprint)
	for part_id, stats in pairs(custom_stats) do
		if stats.falloff_begin_mult then
			self._falloff_begin = math.clamp(self._falloff_begin * stats.falloff_begin_mult, 0, 200000)
		end
		if stats.falloff_end_mult then
			self._falloff_end = math.clamp(self._falloff_end * stats.falloff_begin_mult, 0, 200000)
		end
		if stats.falloff_min_dmg_penalty then
			self._falloff_min_dmg_penalty = self._falloff_min_dmg_penalty + stats.falloff_min_dmg_penalty
		end
	end
end)

function NewRaycastWeaponBase:get_damage_falloff(damage, col_ray, user_unit, distance)
	damage = damage or 1
	local range = col_ray.distance or mvector3.distance(col_ray.unit:position(), user_unit:position())
	local falloff_min_final = (damage - (self._falloff_min_dmg or damage)) + (self._falloff_min_dmg_penalty * 0.1) -- * 0.1
	local dmg_penalty_max = 0
	if falloff_min_final > 0 and falloff_min_final < damage then
		dmg_penalty_max = falloff_min_final
	elseif falloff_min_final > damage then
		dmg_penalty_max = damage
	end
	--local dmg_penalty_max = math.clamp((damage - (self._falloff_min_dmg or damage)) + (self._falloff_min_dmg_penalty * 0.1), 0, damage)
	-- ^ this looks better but doesn't work as well because for some reason it returns broken numbers with -0.000002 differences >:(   -KW
	local dmg_penalty = 0
	if (range > self._falloff_begin) and (range < self._falloff_end) then
		dmg_penalty = dmg_penalty_max * (range - self._falloff_begin)/(self._falloff_end - self._falloff_begin)
	elseif range > self._falloff_end then
		dmg_penalty = dmg_penalty_max
	end
	return damage - dmg_penalty
end